/**
 ******************************************************************************
 * @addtogroup UAVObjects OpenPilot UAVObjects
 * @{ 
 * @addtogroup PipXtremeModemSettings PipXtremeModemSettings 
 * @brief Settings for the @ref PipXtremeModemSettings
 *
 * Autogenerated files and functions for PipXtremeModemSettings Object
 
 * @{ 
 *
 * @file       pipxtrememodemsettings.h
 * @author     The OpenPilot Team, http://www.openpilot.org Copyright (C) 2010.
 * @brief      Implementation of the PipXtremeModemSettings object. This file has been 
 *             automatically generated by the UAVObjectGenerator.
 * 
 * @note       Object definition file: pipxtrememodemsettings.xml. 
 *             This is an automatically generated file.
 *             DO NOT modify manually.
 *
 * @see        The GNU Public License (GPL) Version 3
 *
 *****************************************************************************/
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#ifndef PIPXTREMEMODEMSETTINGS_H
#define PIPXTREMEMODEMSETTINGS_H

// Object constants
#define PIPXTREMEMODEMSETTINGS_OBJID 3841416984U
#define PIPXTREMEMODEMSETTINGS_NAME "PipXtremeModemSettings"
#define PIPXTREMEMODEMSETTINGS_METANAME "PipXtremeModemSettingsMeta"
#define PIPXTREMEMODEMSETTINGS_ISSINGLEINST 1
#define PIPXTREMEMODEMSETTINGS_ISSETTINGS 1
#define PIPXTREMEMODEMSETTINGS_NUMBYTES sizeof(PipXtremeModemSettingsData)

// Object access macros
/**
 * @function PipXtremeModemSettingsGet(dataOut)
 * @brief Populate a PipXtremeModemSettingsData object
 * @param[out] dataOut 
 */
#define PipXtremeModemSettingsGet(dataOut) UAVObjGetData(PipXtremeModemSettingsHandle(), dataOut)
#define PipXtremeModemSettingsSet(dataIn) UAVObjSetData(PipXtremeModemSettingsHandle(), dataIn)
#define PipXtremeModemSettingsInstGet(instId, dataOut) UAVObjGetInstanceData(PipXtremeModemSettingsHandle(), instId, dataOut)
#define PipXtremeModemSettingsInstSet(instId, dataIn) UAVObjSetInstanceData(PipXtremeModemSettingsHandle(), instId, dataIn)
#define PipXtremeModemSettingsConnectQueue(queue) UAVObjConnectQueue(PipXtremeModemSettingsHandle(), queue, EV_MASK_ALL_UPDATES)
#define PipXtremeModemSettingsConnectCallback(cb) UAVObjConnectCallback(PipXtremeModemSettingsHandle(), cb, EV_MASK_ALL_UPDATES)
#define PipXtremeModemSettingsCreateInstance() UAVObjCreateInstance(PipXtremeModemSettingsHandle())
#define PipXtremeModemSettingsRequestUpdate() UAVObjRequestUpdate(PipXtremeModemSettingsHandle())
#define PipXtremeModemSettingsRequestInstUpdate(instId) UAVObjRequestInstanceUpdate(PipXtremeModemSettingsHandle(), instId)
#define PipXtremeModemSettingsUpdated() UAVObjUpdated(PipXtremeModemSettingsHandle())
#define PipXtremeModemSettingsInstUpdated(instId) UAVObjUpdated(PipXtremeModemSettingsHandle(), instId)
#define PipXtremeModemSettingsGetMetadata(dataOut) UAVObjGetMetadata(PipXtremeModemSettingsHandle(), dataOut)
#define PipXtremeModemSettingsSetMetadata(dataIn) UAVObjSetMetadata(PipXtremeModemSettingsHandle(), dataIn)
#define PipXtremeModemSettingsReadOnly(dataIn) UAVObjReadOnly(PipXtremeModemSettingsHandle())

// Object data
typedef struct {
    uint8_t Frequency calibration;
    uint32_t Frequency min;
    uint32_t Frequency max;
    uint32_t Frequency;
    uint8_t RF bandwidth;
    uint8_t Max Tx power;
    uint8_t AESEncryption;
    uint8_t AESEncryptionKey[16];
    uint32_t PairedSerialNumberCRC;

} __attribute__((packed)) PipXtremeModemSettingsData;

// Field information
// Field Frequency calibration information
// Field Frequency min information
// Field Frequency max information
// Field Frequency information
// Field RF bandwidth information
/* Enumeration options for field RF bandwidth */
typedef enum { PIPXTREMEMODEMSETTINGS_RF BANDWIDTH_500=0, PIPXTREMEMODEMSETTINGS_RF BANDWIDTH_1000=1, PIPXTREMEMODEMSETTINGS_RF BANDWIDTH_2000=2, PIPXTREMEMODEMSETTINGS_RF BANDWIDTH_4000=3, PIPXTREMEMODEMSETTINGS_RF BANDWIDTH_8000=4, PIPXTREMEMODEMSETTINGS_RF BANDWIDTH_9600=5, PIPXTREMEMODEMSETTINGS_RF BANDWIDTH_16000=6, PIPXTREMEMODEMSETTINGS_RF BANDWIDTH_19200=7, PIPXTREMEMODEMSETTINGS_RF BANDWIDTH_24000=8, PIPXTREMEMODEMSETTINGS_RF BANDWIDTH_32000=9, PIPXTREMEMODEMSETTINGS_RF BANDWIDTH_64000=10, PIPXTREMEMODEMSETTINGS_RF BANDWIDTH_128000=11, PIPXTREMEMODEMSETTINGS_RF BANDWIDTH_192000=12 } PipXtremeModemSettingsRF bandwidthOptions;
// Field Max Tx power information
/* Enumeration options for field Max Tx power */
typedef enum { PIPXTREMEMODEMSETTINGS_MAX TX POWER_1=0, PIPXTREMEMODEMSETTINGS_MAX TX POWER_2=1, PIPXTREMEMODEMSETTINGS_MAX TX POWER_5=2, PIPXTREMEMODEMSETTINGS_MAX TX POWER_8=3, PIPXTREMEMODEMSETTINGS_MAX TX POWER_11=4, PIPXTREMEMODEMSETTINGS_MAX TX POWER_14=5, PIPXTREMEMODEMSETTINGS_MAX TX POWER_17=6, PIPXTREMEMODEMSETTINGS_MAX TX POWER_20=7 } PipXtremeModemSettingsMax Tx powerOptions;
// Field AESEncryption information
/* Enumeration options for field AESEncryption */
typedef enum { PIPXTREMEMODEMSETTINGS_AESENCRYPTION_FALSE=0, PIPXTREMEMODEMSETTINGS_AESENCRYPTION_TRUE=1 } PipXtremeModemSettingsAESEncryptionOptions;
// Field AESEncryptionKey information
/* Number of elements for field AESEncryptionKey */
#define PIPXTREMEMODEMSETTINGS_AESENCRYPTIONKEY_NUMELEM 16
// Field PairedSerialNumberCRC information


// Generic interface functions
int32_t PipXtremeModemSettingsInitialize();
UAVObjHandle PipXtremeModemSettingsHandle();

#endif // PIPXTREMEMODEMSETTINGS_H

/**
 * @}
 * @}
 */
