/**
 ******************************************************************************
 * @addtogroup UAVObjects OpenPilot UAVObjects
 * @{ 
 * @addtogroup PipXtremeModemStatus PipXtremeModemStatus 
 * @brief Status for the @ref PipXtremeModem
 *
 * Autogenerated files and functions for PipXtremeModemStatus Object
 
 * @{ 
 *
 * @file       pipxtrememodemstatus.h
 * @author     The OpenPilot Team, http://www.openpilot.org Copyright (C) 2010.
 * @brief      Implementation of the PipXtremeModemStatus object. This file has been 
 *             automatically generated by the UAVObjectGenerator.
 * 
 * @note       Object definition file: pipxtrememodemstatus.xml. 
 *             This is an automatically generated file.
 *             DO NOT modify manually.
 *
 * @see        The GNU Public License (GPL) Version 3
 *
 *****************************************************************************/
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#ifndef PIPXTREMEMODEMSTATUS_H
#define PIPXTREMEMODEMSTATUS_H

// Object constants
#define PIPXTREMEMODEMSTATUS_OBJID 2584820952U
#define PIPXTREMEMODEMSTATUS_NAME "PipXtremeModemStatus"
#define PIPXTREMEMODEMSTATUS_METANAME "PipXtremeModemStatusMeta"
#define PIPXTREMEMODEMSTATUS_ISSINGLEINST 1
#define PIPXTREMEMODEMSTATUS_ISSETTINGS 0
#define PIPXTREMEMODEMSTATUS_NUMBYTES sizeof(PipXtremeModemStatusData)

// Object access macros
/**
 * @function PipXtremeModemStatusGet(dataOut)
 * @brief Populate a PipXtremeModemStatusData object
 * @param[out] dataOut 
 */
#define PipXtremeModemStatusGet(dataOut) UAVObjGetData(PipXtremeModemStatusHandle(), dataOut)
#define PipXtremeModemStatusSet(dataIn) UAVObjSetData(PipXtremeModemStatusHandle(), dataIn)
#define PipXtremeModemStatusInstGet(instId, dataOut) UAVObjGetInstanceData(PipXtremeModemStatusHandle(), instId, dataOut)
#define PipXtremeModemStatusInstSet(instId, dataIn) UAVObjSetInstanceData(PipXtremeModemStatusHandle(), instId, dataIn)
#define PipXtremeModemStatusConnectQueue(queue) UAVObjConnectQueue(PipXtremeModemStatusHandle(), queue, EV_MASK_ALL_UPDATES)
#define PipXtremeModemStatusConnectCallback(cb) UAVObjConnectCallback(PipXtremeModemStatusHandle(), cb, EV_MASK_ALL_UPDATES)
#define PipXtremeModemStatusCreateInstance() UAVObjCreateInstance(PipXtremeModemStatusHandle())
#define PipXtremeModemStatusRequestUpdate() UAVObjRequestUpdate(PipXtremeModemStatusHandle())
#define PipXtremeModemStatusRequestInstUpdate(instId) UAVObjRequestInstanceUpdate(PipXtremeModemStatusHandle(), instId)
#define PipXtremeModemStatusUpdated() UAVObjUpdated(PipXtremeModemStatusHandle())
#define PipXtremeModemStatusInstUpdated(instId) UAVObjUpdated(PipXtremeModemStatusHandle(), instId)
#define PipXtremeModemStatusGetMetadata(dataOut) UAVObjGetMetadata(PipXtremeModemStatusHandle(), dataOut)
#define PipXtremeModemStatusSetMetadata(dataIn) UAVObjSetMetadata(PipXtremeModemStatusHandle(), dataIn)
#define PipXtremeModemStatusReadOnly(dataIn) UAVObjReadOnly(PipXtremeModemStatusHandle())

// Object data
typedef struct {
    uint8_t SerialNumber[24];
    uint32_t SerialNumberCRC;
    uint32_t UpTime;
    uint32_t Frequency;
    uint32_t RFBandwidth;
    int8_t TxPower;
    uint8_t State;
    uint16_t TxRetry;
    uint32_t TxDataRate;
    uint32_t RxDataRate;

} __attribute__((packed)) PipXtremeModemStatusData;

// Field information
// Field SerialNumber information
/* Number of elements for field SerialNumber */
#define PIPXTREMEMODEMSTATUS_SERIALNUMBER_NUMELEM 24
// Field SerialNumberCRC information
// Field UpTime information
// Field Frequency information
// Field RFBandwidth information
// Field TxPower information
// Field State information
/* Enumeration options for field State */
typedef enum { PIPXTREMEMODEMSTATUS_STATE_DISCONNECTED=0, PIPXTREMEMODEMSTATUS_STATE_CONNECTING=1, PIPXTREMEMODEMSTATUS_STATE_CONNECTED=2, PIPXTREMEMODEMSTATUS_STATE_NOTREADY=3 } PipXtremeModemStatusStateOptions;
// Field TxRetry information
// Field TxDataRate information
// Field RxDataRate information


// Generic interface functions
int32_t PipXtremeModemStatusInitialize();
UAVObjHandle PipXtremeModemStatusHandle();

#endif // PIPXTREMEMODEMSTATUS_H

/**
 * @}
 * @}
 */
