/**
 ******************************************************************************
 * @addtogroup UAVObjects OpenPilot UAVObjects
 * @{ 
 * @addtogroup PipXtremeModemSettings PipXtremeModemSettings
 * @brief Settings for the @ref PipXtremeModemSettings
 *
 * Autogenerated files and functions for PipXtremeModemSettings Object
 * @{ 
 *
 * @file       pipxtrememodemsettings.c
 * @author     The OpenPilot Team, http://www.openpilot.org Copyright (C) 2010.
 * @brief      Implementation of the PipXtremeModemSettings object. This file has been 
 *             automatically generated by the UAVObjectGenerator.
 * 
 * @note       Object definition file: pipxtrememodemsettings.xml. 
 *             This is an automatically generated file.
 *             DO NOT modify manually.
 *
 * @see        The GNU Public License (GPL) Version 3
 *
 *****************************************************************************/
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#include "openpilot.h"
#include "pipxtrememodemsettings.h"

// Private variables
static UAVObjHandle handle;

// Private functions
static void setDefaults(UAVObjHandle obj, uint16_t instId);

/**
 * Initialize object.
 * \return 0 Success
 * \return -1 Failure
 */
int32_t PipXtremeModemSettingsInitialize()
{
	// Register object with the object manager
	handle = UAVObjRegister(PIPXTREMEMODEMSETTINGS_OBJID, PIPXTREMEMODEMSETTINGS_NAME, PIPXTREMEMODEMSETTINGS_METANAME, 0,
			PIPXTREMEMODEMSETTINGS_ISSINGLEINST, PIPXTREMEMODEMSETTINGS_ISSETTINGS, PIPXTREMEMODEMSETTINGS_NUMBYTES, &setDefaults);

	// Done
	if (handle != 0)
	{
		return 0;
	}
	else
	{
		return -1;
	}
}

/**
 * Initialize object fields and metadata with the default values.
 * If a default value is not specified the object fields
 * will be initialized to zero.
 */
static void setDefaults(UAVObjHandle obj, uint16_t instId)
{
	PipXtremeModemSettingsData data;
	UAVObjMetadata metadata;

	// Initialize object fields to their default values
	UAVObjGetInstanceData(obj, instId, &data);
	memset(&data, 0, sizeof(PipXtremeModemSettingsData));
	data.Frequency calibration = 127;
	data.Frequency min = 0;
	data.Frequency max = 0;
	data.Frequency = 0;
	data.RF bandwidth = 11;
	data.Max Tx power = 4;
	data.AESEncryption = 0;
	data.AESEncryptionKey[0] = 0;
	data.AESEncryptionKey[1] = 0;
	data.AESEncryptionKey[2] = 0;
	data.AESEncryptionKey[3] = 0;
	data.AESEncryptionKey[4] = 0;
	data.AESEncryptionKey[5] = 0;
	data.AESEncryptionKey[6] = 0;
	data.AESEncryptionKey[7] = 0;
	data.AESEncryptionKey[8] = 0;
	data.AESEncryptionKey[9] = 0;
	data.AESEncryptionKey[10] = 0;
	data.AESEncryptionKey[11] = 0;
	data.AESEncryptionKey[12] = 0;
	data.AESEncryptionKey[13] = 0;
	data.AESEncryptionKey[14] = 0;
	data.AESEncryptionKey[15] = 0;
	data.PairedSerialNumberCRC = 0;

	UAVObjSetInstanceData(obj, instId, &data);

	// Initialize object metadata to their default values
	metadata.access = ACCESS_READWRITE;
	metadata.gcsAccess = ACCESS_READWRITE;
	metadata.telemetryAcked = 1;
	metadata.telemetryUpdateMode = UPDATEMODE_ONCHANGE;
	metadata.telemetryUpdatePeriod = 0;
	metadata.gcsTelemetryAcked = 1;
	metadata.gcsTelemetryUpdateMode = UPDATEMODE_ONCHANGE;
	metadata.gcsTelemetryUpdatePeriod = 0;
	metadata.loggingUpdateMode = UPDATEMODE_NEVER;
	metadata.loggingUpdatePeriod = 0;
	UAVObjSetMetadata(obj, &metadata);
}

/**
 * Get object handle
 */
UAVObjHandle PipXtremeModemSettingsHandle()
{
	return handle;
}

/**
 * @}
 */

