/**
 ******************************************************************************
 * @addtogroup UAVObjects OpenPilot UAVObjects
 * @{ 
 * @addtogroup PipXtremeModemStatus PipXtremeModemStatus
 * @brief Status for the @ref PipXtremeModem
 *
 * Autogenerated files and functions for PipXtremeModemStatus Object
 * @{ 
 *
 * @file       pipxtrememodemstatus.c
 * @author     The OpenPilot Team, http://www.openpilot.org Copyright (C) 2010.
 * @brief      Implementation of the PipXtremeModemStatus object. This file has been 
 *             automatically generated by the UAVObjectGenerator.
 * 
 * @note       Object definition file: pipxtrememodemstatus.xml. 
 *             This is an automatically generated file.
 *             DO NOT modify manually.
 *
 * @see        The GNU Public License (GPL) Version 3
 *
 *****************************************************************************/
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#include "openpilot.h"
#include "pipxtrememodemstatus.h"

// Private variables
static UAVObjHandle handle;

// Private functions
static void setDefaults(UAVObjHandle obj, uint16_t instId);

/**
 * Initialize object.
 * \return 0 Success
 * \return -1 Failure
 */
int32_t PipXtremeModemStatusInitialize()
{
	// Register object with the object manager
	handle = UAVObjRegister(PIPXTREMEMODEMSTATUS_OBJID, PIPXTREMEMODEMSTATUS_NAME, PIPXTREMEMODEMSTATUS_METANAME, 0,
			PIPXTREMEMODEMSTATUS_ISSINGLEINST, PIPXTREMEMODEMSTATUS_ISSETTINGS, PIPXTREMEMODEMSTATUS_NUMBYTES, &setDefaults);

	// Done
	if (handle != 0)
	{
		return 0;
	}
	else
	{
		return -1;
	}
}

/**
 * Initialize object fields and metadata with the default values.
 * If a default value is not specified the object fields
 * will be initialized to zero.
 */
static void setDefaults(UAVObjHandle obj, uint16_t instId)
{
	PipXtremeModemStatusData data;
	UAVObjMetadata metadata;

	// Initialize object fields to their default values
	UAVObjGetInstanceData(obj, instId, &data);
	memset(&data, 0, sizeof(PipXtremeModemStatusData));
	data.SerialNumber[0] = 0;
	data.SerialNumber[1] = 0;
	data.SerialNumber[2] = 0;
	data.SerialNumber[3] = 0;
	data.SerialNumber[4] = 0;
	data.SerialNumber[5] = 0;
	data.SerialNumber[6] = 0;
	data.SerialNumber[7] = 0;
	data.SerialNumber[8] = 0;
	data.SerialNumber[9] = 0;
	data.SerialNumber[10] = 0;
	data.SerialNumber[11] = 0;
	data.SerialNumber[12] = 0;
	data.SerialNumber[13] = 0;
	data.SerialNumber[14] = 0;
	data.SerialNumber[15] = 0;
	data.SerialNumber[16] = 0;
	data.SerialNumber[17] = 0;
	data.SerialNumber[18] = 0;
	data.SerialNumber[19] = 0;
	data.SerialNumber[20] = 0;
	data.SerialNumber[21] = 0;
	data.SerialNumber[22] = 0;
	data.SerialNumber[23] = 0;
	data.SerialNumberCRC = 0;

	UAVObjSetInstanceData(obj, instId, &data);

	// Initialize object metadata to their default values
	metadata.access = ACCESS_READWRITE;
	metadata.gcsAccess = ACCESS_READWRITE;
	metadata.telemetryAcked = 0;
	metadata.telemetryUpdateMode = UPDATEMODE_PERIODIC;
	metadata.telemetryUpdatePeriod = 5000;
	metadata.gcsTelemetryAcked = 0;
	metadata.gcsTelemetryUpdateMode = UPDATEMODE_MANUAL;
	metadata.gcsTelemetryUpdatePeriod = 0;
	metadata.loggingUpdateMode = UPDATEMODE_NEVER;
	metadata.loggingUpdatePeriod = 0;
	UAVObjSetMetadata(obj, &metadata);
}

/**
 * Get object handle
 */
UAVObjHandle PipXtremeModemStatusHandle()
{
	return handle;
}

/**
 * @}
 */

